//+------------------------------------------------------------------+ 
//|                         _TRO_OPENS                               | 
//|                                                                  | 
//|                                                                  | 
//|   Copyright  2008, Avery T. Horton, Jr. aka TheRumpledOne       |
//|                                                                  |
//|   PO BOX 43575, TUCSON, AZ 85733                                 |
//|                                                                  |
//|   GIFTS AND DONATIONS ACCEPTED                                   | 
//|                                                                  |
//|   therumpledone@gmail.com                                        |  
//+------------------------------------------------------------------+ 

#property  copyright "Copyright  2008, Avery T. Horton, Jr. aka TRO" 
#property  link      "http://www.therumpledone.com/" 

#property indicator_chart_window 
#property indicator_buffers 8 

#property indicator_color1 Yellow
#property indicator_color2 Orange 
#property indicator_color3 Red
#property indicator_color4 Bisque 
#property indicator_color5 Pink
#property indicator_color6 PaleGreen
#property indicator_color7 White  
#property indicator_color8 DodgerBlue 


//---- input parameters 

extern bool alert.M1  = false ;
extern bool alert.M5  = false ;
extern bool alert.M15 = false ;
extern bool alert.H1  = false ;
extern bool alert.H4  = false ;
extern bool alert.D1  = false ;
extern bool alert.W1  = true ;
extern bool alert.MN1 = false ;

extern   int      max_bars=300; 

extern bool show.M1  = false ;
extern bool show.M5  = false ;
extern bool show.M15 = false ;
extern bool show.H1  = false ;
extern bool show.H4  = false ;
extern bool show.D1  = false ;
extern bool show.W1  = true ;
extern bool show.MN1 = false ;



extern color color_M1  = Yellow ;
extern color color_M5  = Orange ;
extern color color_M15 = Red ;
extern color color_H1  = Bisque ; 
extern color color_H4  = Pink ;
extern color color_D1  = PaleGreen ; 
extern color color_W1  = White;
extern color color_MN1 = DodgerBlue ;


//---- buffers 

double PlotM1[]; 
double PlotM5[]; 
double PlotM15[]; 
double PlotH1[]; 
double PlotH4[]; 
double PlotD1[]; 
double PlotW1[]; 
double PlotMN1[]; 

datetime trigger.M1  = 0;
datetime trigger.M5  = 0;
datetime trigger.M15 = 0;
datetime trigger.H1  = 0;
datetime trigger.H4  = 0;
datetime trigger.D1  = 0;
datetime trigger.W1  = 0 ;
datetime trigger.MN1 = 0;

datetime Trigger ;

int    digits, period  ; 
string symbol, tChartPeriod ;  
double point;

//+------------------------------------------------------------------+ 

double xOpen( int oPeriod, int oShift ) 
{
    int BarShift   = iBarShift(NULL,oPeriod,Time[oShift],true); 
    double oOpen   = iOpen(NULL,oPeriod,BarShift); 
    
return(oOpen) ;
}

//+------------------------------------------------------------------+ 
//| Custom indicator initialization function                         | 
//+------------------------------------------------------------------+ 
int init() 
  { 
  
   period       =  Period() ;    
   symbol       =  Symbol() ;
   digits       =  Digits ;   
   point        =  Point ;

   if(digits == 5 || digits == 3) { digits = digits - 1 ; point = point * 10 ; }   
     
  
//---- indicators 
   SetIndexStyle(0,DRAW_LINE,STYLE_SOLID,1,color_M1); 
   SetIndexArrow(0,119); 
   SetIndexBuffer(0,PlotM5); 
   SetIndexEmptyValue(0,0.0); 
   SetIndexStyle(1,DRAW_LINE,STYLE_SOLID,1,color_M5);  
   SetIndexArrow(1,119); 
   SetIndexBuffer(1,PlotM5); 
   SetIndexEmptyValue(1,0.0); 
   SetIndexStyle(2,DRAW_LINE,STYLE_SOLID,1,color_M15);  
   SetIndexArrow(2,119); 
   SetIndexBuffer(2,PlotM15); 
   SetIndexEmptyValue(2,0.0); 
   SetIndexStyle(3,DRAW_LINE,STYLE_SOLID,1,color_H1);  
   SetIndexArrow(3,119); 
   SetIndexBuffer(3,PlotH1); 
   SetIndexEmptyValue(3,0.0); 
   SetIndexStyle(4,DRAW_LINE,STYLE_SOLID,1,color_H4);  
   SetIndexArrow(4,119); 
   SetIndexBuffer(4,PlotH4); 
   SetIndexEmptyValue(4,0.0); 
   
   SetIndexStyle(5,DRAW_LINE,STYLE_SOLID,1,color_D1);  
   SetIndexArrow(5,119); 
   SetIndexBuffer(5,PlotD1); 
   SetIndexEmptyValue(5,0.0); 
   SetIndexStyle(6,DRAW_LINE,STYLE_SOLID,1,color_W1);  
   SetIndexArrow(6,119); 
   SetIndexBuffer(6,PlotW1); 
   SetIndexEmptyValue(6,0.0); 
   SetIndexStyle(7,DRAW_LINE,STYLE_SOLID,1,color_MN1);  
   SetIndexArrow(7,119); 
   SetIndexBuffer(7,PlotMN1); 
   SetIndexEmptyValue(7,0.0); 
   
//---- 
   deinit() ;
   return(0); 
  }  
//+------------------------------------------------------------------+ 
int deinit() 
  { 
//---- 
   ObjectDelete("Op1");    
   ObjectDelete("Op2");       
   ObjectDelete("Op3");    
   ObjectDelete("Op4");   
   ObjectDelete("Op5");    
   ObjectDelete("Op6");       
   ObjectDelete("Op7");    
   ObjectDelete("Op8");    
//---- 

    TRO();
    
   return(0); 
  }  
//+------------------------------------------------------------------+ 
int start() 
  { 
   int    counted_bars=IndicatorCounted(); 
    if(counted_bars < 0) 
        return(-1); 
//---- 
   int limit=Bars-counted_bars; 
    

   int processBars=MathMin(limit, max_bars); 
   for(int i=0;i<=processBars;i++){ 
 
//    int BarShift   = iBarShift(NULL,PERIOD_H1,Time[i],true); 
//    double OpenH1  = iOpen(NULL,PERIOD_H1,BarShift); 
    
if( show.M1 )  PlotM1[i]  = xOpen(PERIOD_M1,i ) ;                       
if( show.M5 )  PlotM5[i]  = xOpen(PERIOD_M5,i ) ; 
if( show.M15 ) PlotM15[i] = xOpen(PERIOD_M15,i ) ; 
if( show.H1 )  PlotH1[i]  = xOpen(PERIOD_H1,i ) ; 
if( show.H4 )  PlotH4[i]  = xOpen(PERIOD_H4,i ) ; 
if( show.D1 )  PlotD1[i]  = xOpen(PERIOD_D1,i ) ; 
if( show.W1 )  PlotW1[i]  = xOpen(PERIOD_W1,i ) ; 
if( show.MN1 ) PlotMN1[i] = xOpen(PERIOD_MN1,i ) ; 
   
   } //end for 

 

if( show.M1 )  DoLabel( "Op1" , PlotM1[0]  , color_M1 ) ;
if( show.M5 )  DoLabel( "Op2" , PlotM5[0]  , color_M5 ) ;
if( show.M15 ) DoLabel( "Op3" , PlotM15[0] , color_M15 ) ;
if( show.H1 )  DoLabel( "Op4" , PlotH1[0]  , color_H1 ) ;
if( show.H4 )  DoLabel( "Op5" , PlotH4[0]  , color_H4 ) ;
if( show.D1 )  DoLabel( "Op6" , PlotD1[0]  , color_D1 ) ;
if( show.W1 )  DoLabel( "Op7" , PlotW1[0]  , color_W1 ) ;
if( show.MN1 ) DoLabel( "Op8" , PlotMN1[0] , color_MN1 ) ;


if( alert.M1 )  DoAlert(PERIOD_M1 , PlotM1[0] ) ;                       
if( alert.M5 )  DoAlert(PERIOD_M5 , PlotM5[0] ) ; 
if( alert.M15 ) DoAlert(PERIOD_M15 , PlotM15[0] ) ; 
if( alert.H1 )  DoAlert(PERIOD_H1 , PlotH1[0] ) ; 
if( alert.H4 )  DoAlert(PERIOD_H4 , PlotH4[0] ) ; 
if( alert.D1 )  DoAlert(PERIOD_D1 , PlotD1[0] ) ; 
if( alert.W1 )  DoAlert(PERIOD_W1 , PlotW1[0] ) ; 
if( alert.MN1 ) DoAlert(PERIOD_MN1 , PlotMN1[0] ) ; 


   return(0); 
  } 
//+------------------------------------------------------------------+ 

void DoLabel( string dName, double dValue, color dColor )
{

     if (ObjectFind(dName) != 0)
      {
          ObjectCreate(dName,OBJ_ARROW,0,Time[0],dValue);
          ObjectSet(dName,OBJPROP_ARROWCODE,SYMBOL_RIGHTPRICE);
          ObjectSet(dName,OBJPROP_COLOR,dColor);  
      } 
      else
      {
         ObjectMove(dName,0,Time[0],dValue);
      }
      
}
//+------------------------------------------------------------------+      
void DoAlert( int aPeriod , double aOpen )
{
 
if ( Trigger != TimeMinute( TimeCurrent () ) )
{

double    O,H,L,C;
 
string aTF = TimeFrameToString( aPeriod );
   
      C        = iClose(NULL,1, 0) ; 
//      O        = iOpen(NULL,aPeriod, 0) ; 
      H        = iHigh(NULL,1, 0) ; 
      L        = iLow(NULL,1, 0) ; 

   if( C > aOpen && aOpen > L ) { Trigger = TimeMinute( TimeCurrent () )  ; Alert(symbol," " + aTF + " Crossed Above Open " +  DoubleToStr(aOpen ,digits)); }
   if( C < aOpen && aOpen < H ) { Trigger = TimeMinute( TimeCurrent () )  ; Alert(symbol," " + aTF + " Crossed Below Open " +  DoubleToStr(aOpen ,digits)); }
      
} // if

}   

//+--------- TRO MODIFICATION ---------------------------------------+  

string TimeFrameToString(int tf)
{
   string tfs;
   switch(tf) {
      case PERIOD_M1:  tfs="M1"  ; break;
      case PERIOD_M5:  tfs="M5"  ; break;
      case PERIOD_M15: tfs="M15" ; break;
      case PERIOD_M30: tfs="M30" ; break;
      case PERIOD_H1:  tfs="H1"  ; break;
      case PERIOD_H4:  tfs="H4"  ; break;
      case PERIOD_D1:  tfs="D1"  ; break;
      case PERIOD_W1:  tfs="W1"  ; break;
      case PERIOD_MN1: tfs="MN";
   }
   return(tfs);
}
//+------------------------------------------------------------------+  
void TRO()
{   
   
   string tObjName03    = "TROTAG"  ;  
   ObjectCreate(tObjName03, OBJ_LABEL, 0, 0, 0);//HiLow LABEL
   ObjectSetText(tObjName03, CharToStr(78) , 12 ,  "Wingdings",  DimGray );
   ObjectSet(tObjName03, OBJPROP_CORNER, 3);
   ObjectSet(tObjName03, OBJPROP_XDISTANCE, 5 );
   ObjectSet(tObjName03, OBJPROP_YDISTANCE, 5 );  
}
 
//+------------------------------------------------------------------+
   